import { Router } from '@angular/router';
import { MonkeyEcxPaginationService, MonkeyEcxTranslateOptions } from '..';
import { MonkeyEcxFeatureToggleService } from '../services';
import { MonkeyEcxConfig } from './monkeyecx-config';
import { MonkeyEcxCountrySecurity } from './monkeyecx-country-security';
export interface MonkeyEcxCommonsSearch {
    buildParams(): string;
}
export interface MonkeyEcxInitialResolverConfig {
    route: string;
    searchClass?: new (data: any) => MonkeyEcxCommonsSearch;
}
export interface MonkeyEcxCommonsConfig {
    companyType?: string;
    callbackMain: Function;
    router?: Router;
    callbackPagination?: Function;
    translateOptions?: MonkeyEcxTranslateOptions;
    feature?: {
        service: MonkeyEcxFeatureToggleService;
        flag: string;
    };
    featureByProgram?: {
        config: MonkeyEcxConfig;
        feature: string;
    };
    countrySecurity?: MonkeyEcxCountrySecurity;
    pendency?: {
        service: {
            hasPendencies: Function;
        };
        type: string;
    };
    paginationOptions?: {
        service: MonkeyEcxPaginationService;
        callback: Function;
        name?: string;
    };
}
