import { Action } from '@ngrx/store';
import { Link } from '../model';
export interface MonkeyEcxConfigStore {
    actions?: {};
    selectors?: {};
}
export interface MonkeyEcxCollectionStore extends MonkeyEcxConfigStore {
    actions: {
        updateControl: Action;
        updateLinks: Action;
        updatePage: Action;
        updateAll: Action;
        clear: Action;
    };
    selectors: {
        linksHasDifference?: Function;
        selectLinks: Function;
    };
}
export interface MonkeyEcxEntityStore extends MonkeyEcxConfigStore {
    actions: {
        updateControl: Action;
        updateOne: Action;
    };
}
export interface MonkeyEcxControlStore {
    [key: string]: any;
}
export interface MonkeyEcxLinks {
    [key: string]: Link;
}
