import { HttpErrorResponse } from '@angular/common/http';
import { Router } from '@angular/router';
import { TranslateService } from '@ngx-translate/core';
import { MonkeyStyleGuideSnackbarService } from 'monkey-style-guide';
import { MonkeyEcxServiceCredentials } from '../../interfaces';
import { MonkeyEcxAuthenticationService } from '../auth';
import { MonkeyEcxCommonsService } from '../commons';
import { MonkeyEcxService } from '../monkeyecx-service.service';
import { MonkeyEcxTokenStorageService } from '../storage';
import * as i0 from "@angular/core";
export declare class MonkeyEcxHttpErrorHandlingService extends MonkeyEcxCommonsService {
    private monkeyecxAuthenticationService;
    private router;
    private snackbarService;
    private translateService;
    constructor(monkeyecxService: MonkeyEcxService, tokenStorage: MonkeyEcxTokenStorageService, monkeyecxAuthenticationService: MonkeyEcxAuthenticationService, router: Router, snackbarService: MonkeyStyleGuideSnackbarService, translateService: TranslateService);
    private isHttpCodeIgnoreMessage;
    private isHttpCodeIgnoreRedirect;
    private getMessageType;
    private showMessage;
    private handleMessage;
    handleError(error: HttpErrorResponse, mkc: MonkeyEcxServiceCredentials): Promise<void>;
    handleErrorRefreshToken(error: HttpErrorResponse, mkc: MonkeyEcxServiceCredentials): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MonkeyEcxHttpErrorHandlingService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<MonkeyEcxHttpErrorHandlingService>;
}
